---- update 2011/01/09

function FromWS( str )
	if str then return userMods.FromWString( str ) end
end

function ToWS( str )
	if str then return userMods.ToWString( str ) end
end

----    
function delRows( tab, rows )
	for k in rows do 
		exObj("key:",k)
		tab[k] = nil
	end
end

---   
function subTable( tab1, tab2 )
	local subTab = {}
	for k,v in pairs(tab1) do 
		exObj("key:",k)
		exObj("value:",v)
		if tab2[k] ~= v then
			subTab[k] = v
		end
	end
	return subTab
end

---   ?
function isEmptyTable( tab )
	for _,_ in pairs(tab) do 
		return false
	end
	return true
end

---         
--- meta=true  -   
function exObj(tab,obj,meta) --- explore an object

	--- 
	if string.len (tab) > 100 then 
		LogInfo ("  !")
		return 
	end 

	if meta then
		local metaTable = getmetatable (obj)
		if metaTable then
			exObj(tab.." meta" , metaTable)
		end
	end
	----LogInfo(tab, "{",type(obj),"}")
	if type(obj) == "table" then
		----   () 
		---if obj == {} then
		---	LogInfo ( tab, "{}")
		---	return
		---	end
		LogInfo(tab, "{")
		for k,v in pairs(obj) do 
			---LogInfo ( tab, k,":=",v,  "{", type (v), "}")
			if k == "__index" then
				--- "__index" -           
				---    
				---LogInfo(tab, k)
				---for k1,v1 in pairs(v) do 
				---	LogInfo ( tab, k, " - ",k1," = ",v1,"{", type (v1), "}")
				---end
			elseif k == "__gc" then
			elseif k == "_G" then
			else
				exObj(tab.."."..k , v)
			end
		end
		LogInfo(tab, "}")
	else
		LogInfo ( tab, " = ",obj, "{", type (obj), "}")
	end
end